--[[
Prescription - Copyright (C) 2007 - 2008 Michael Joseph Murray aka Starinnia of Lothar
$Revision: 95 $
$Date: 2009-02-24 20:32:29 +0000 (Tue, 24 Feb 2009) $
contact: codemaster2010 AT gmail DOT com

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not
claim that you wrote the original software. If you use this software
in a product, an acknowledgment in the product documentation would be
appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
]]

Prescription = LibStub("AceAddon-3.0"):NewAddon("Prescription", "AceTimer-3.0", "AceConsole-3.0", "AceEvent-3.0")
local inCombat

Prescription.Battle = {
	"Healing Power", -- Elixir of Healing Power
	"Major Agility", -- Elixir of Major Agility
	"Greater Agility", --Elixir of Greater Agility
	"Major Firepower", -- Elixir of Major Firepower
	"Major Shadow Power", -- Elixir of Major Shadow Power
	"Major Strength", -- Elixir of Major Strength
	"Elixir of Mastery",
	"Major Frost Power", -- Elixir of Major Frost Power
	"Fel Strength Elixir",
	"Greater Arcane Elixir",
	"Onslaught Elixir",
	"Adept's Elixir",
	"Elixir of the Mongoose",
	"Elixir of Brute Force",
	"Arcane Elixir",
	"Greater Firepower", -- Elixir of Greater Firepower
	"Shadow Power", -- Elixir of Shadow Power
	"Elixir of Giants",
	"Elixir of Demonslaying",
	"Bloodberry Elixir",
	--	wotlk elixirs	--
	"Accuracy", --Elixir of Accuracy
	"Armor Piercing", --Elixir of Armor Piercing
	"Deadly Strikes", --Elixir of Deadly Strikes
	"Expertise", --Elixir of Expertise
	"Lightning Speed", -- Elixir of Lightning Speed
	"Mighty Agility", -- Elixir of Mighty Agility
	"Mighty Strength", --Elixir of Mighty Strength
	"Guru's Elixir",
	"Spellpower Elixir",
	"Wrath Elixir",
}

Prescription.Guardian = {
	"Elixir of Draenic Wisdom",
	"Empowerment", -- Elixir of Empowerment
	"Elixir of Ironskin",
	"Major Armor", -- Elixir of Major Defense
	"Elixir of Major Fortitude",
	"Greater Mana Regeneration", -- Elixir of Major Mageblood
	"Elixir of the Sages",
	"Greater Intellect", -- Elixir of Greater Intellect
	"Greater Armor", -- Elixir of Superior Defense
	"Earthen Elixir",
	"Regeneration", --Mighty Troll's Blood Potion
	--	wotlk elixirs	--
	"Mighty Defense", --Elixir of Mighty Defense
	"Elixir of Mighty Fortitude",
	"Mighty Mana Regeneration", --Elixir of Mighty Mageblood
	"Mighty Thoughts", --Elixir of Mighty Thoughts
	"Protection", -- Elixir of Mighty Protection
	"Elixir of Spirit",
}

Prescription.Flask = {
	"Chromatic Resistance", --Flask of Chromatic Resistance
	"Distilled Wisdom", --Flask of Distilled Wisdom
	"Flask of Fortification",
	"Flask of Mighty Restoration",
	"Flask of Relentless Assault",
	"Flask of the Titans",
	"Supreme Power", --Flask of Supreme Power
	"Chromatic Wonder", --Flask of Chromatic Wonder (Honored w/ Violet Eye)
	---      Shattrath Flasks     ---
	"Relentless Assault of Shattrath",
	"Mighty Restoration of Shattrath",
	"Fortification of Shattrath",
	"Supreme Power of Shattrath",
	"Pure Death of Shattrath",
	"Blinding Light of Shattrath",
	---     New Flasks (2.2.0)     ---
	"Flask of Pure Death",
	"Flask of Blinding Light",
	---     Unstable Flasks     ---
	"Unstable Flask of the Beast",
	"Unstable Flask of the Bandit",
	"Unstable Flask of the Elder",
	"Unstable Flask of the Soldier",
	"Unstable Flask of the Physician",
	"Unstable Flask of the Sorcerer",
	--	wotlk flasks		--
	"Flask of Endless Rage",
	"Flask of Pure Mojo",
	"Flask of Stoneblood",
	"Flask of the Frost Wyrm",
	"Lesser Flask of Resistance",
}

Prescription.Food = {
	"Well Fed",
	"\"Well Fed\"", --Brewfest Well Fed buff (hopefully)
	"Enlightened",
	"Increased Stamina",
	"Electrified",
	"Rumsey Rum Black Label",
}

local user = UnitName("player")
local commTable = {}
local shattZones = {
	["Serpentshrine Cavern"] = true,
	["The Eye"] = true,
	["Battle for Mount Hyjal"] = true,
	["Black Temple"] = true,
	["Sunwell Plateau"] = true,
}

function Prescription:OnInitialize()
	local defaults = {
		profile = {
			checkBattle = true,
			checkGuardian = true,
			checkFood = true,
			checkFlask = true,
			sendWhispers = false,
			sendRaid = false,
			sendOfficer = false,
			sendSelf = true,
			blockOutgoing = false,
			delay = 15,
			sendCompliance = true,
		},
	}
	
	self.db = LibStub("AceDB-3.0"):New("PrescriptionDB", defaults, "Default")
	
	local opts = {
		type = 'group',
		args = {
			check = {
				type = 'execute',
				name = "Check Consumables",
				desc = "Check the raid for consumable usage",
				func = function()
					self:ScheduleTimer("Raid_Check", self.db.profile.delay)
					if IsRaidLeader() or IsRaidOfficer() then
						SendChatMessage("RX Check will be run in "..self.db.profile.delay.." seconds!", "RAID_WARNING")
					else
						SendChatMessage("RX Check will be run in "..self.db.profile.delay.." seconds!", "RAID")
					end
				end,
			},
			delay = {
				type = 'range',
				name = "RX Check Delay",
				desc = "Set the delay before a Prescription check is run.",
				get = function() return self.db.profile.delay end,
				set = function(info, v) self.db.profile.delay = v end,
				min = 0,
				max = 30,
				step = 1,
			},
			drugs = {
				type = 'group',
				name = "Prescription Drugs",
				desc = "What do you want to check for?",
				args = {
					battle = {
						type = 'toggle',
						name = "Battle Elixirs",
						desc = "Toggle checking for Battle Elixirs",
						get = function() return self.db.profile.checkBattle end,
						set = function() self.db.profile.checkBattle = not self.db.profile.checkBattle end,
					},
					guardian = {
						type = 'toggle',
						name = "Guardian Elixirs",
						desc = "Toggle checking for Guardian Elixirs",
						get = function() return self.db.profile.checkGuardian end,
						set = function() self.db.profile.checkGuardian = not self.db.profile.checkGuardian end,
					},
					flask = {
						type = 'toggle',
						name = "Flasks",
						desc = "Toggle checking for Flasks",
						get = function() return self.db.profile.checkFlask end,
						set = function() self.db.profile.checkFlask = not self.db.profile.checkFlask end,
					},
					food = {
						type = 'toggle',
						name = "Food Buffs",
						desc = "Toggle checking for Food Buffs",
						get = function() return self.db.profile.checkFood end,
						set = function() self.db.profile.checkFood = not self.db.profile.checkFood end,
					},
				},
			},
			announce = {
				type = 'group',
				name = "Announcements",
				desc = "How to announce Prescriptions",
				args = {
					self = {
						type = 'toggle',
						name = "Self Report",
						desc = "Print consumable report for yourself",
						get = function() return self.db.profile.sendSelf end,
						set = function() self.db.profile.sendSelf = not self.db.profile.sendSelf end,
					},
					whisper = {
						type = 'toggle',
						name = "Whisper Players",
						desc = "Whisper players missing consumables",
						get = function() return self.db.profile.sendWhispers end,
						set = function() self.db.profile.sendWhispers = not self.db.profile.sendWhispers end,
					},
					blockouts = {
						type = 'toggle',
						name = "Block Outgoing Whispers",
						desc = "Toggles blocking of outgoing <Rx> whispers",
						get = function() return self.db.profile.blockOutgoing end,
						set = function() self.db.profile.blockOutgoing = not self.db.profile.blockOutgoing end,
					},
					raid = {
						type = 'toggle',
						name = "Raid Report",
						desc = "Send consumable reports to raid chat",
						get = function() return self.db.profile.sendRaid end,
						set = function() self.db.profile.sendRaid = not self.db.profile.sendRaid end,
					},
					officer = {
						type = 'toggle',
						name = "Officer Report",
						desc = "Send consumable reports to officer chat",
						get = function() return self.db.profile.sendOfficer end,
						set = function() self.db.profile.sendOfficer = not self.db.profile.sendOfficer end,
					},
					compliance = {
						type = 'toggle',
						name = "Compliance Broadcast",
						desc = "Broadcast the percent compliance to the raid after running a check.",
						get = function() return self.db.profile.sendCompliance end,
						set = function() self.db.profile.sendCompliance = not self.db.profile.sendCompliance end,
					},
				},
			},
		},
	}
	opts.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Prescription", opts)
	_G["SlashCmdList"]["PRESCRIPTION_MAIN"] = function(s)
		if string.lower(s) == "check" then
			self:ScheduleTimer("Raid_Check", self.db.profile.delay)
			if IsRaidLeader() or IsRaidOfficer() then
				SendChatMessage("RX Check will be run in "..self.db.profile.delay.." seconds!", "RAID_WARNING")
			else
				SendChatMessage("RX Check will be run in "..self.db.profile.delay.." seconds!", "RAID")
			end
		elseif string.lower(s) == "instant" then
			if IsRaidLeader() or IsRaidOfficer() then
				SendChatMessage("RX Check running now!", "RAID_WARNING")
			else
				SendChatMessage("RX Check running now!", "RAID")
			end
			self:Raid_Check()
		else
			LibStub("AceConfigDialog-3.0"):SetDefaultSize("Prescription", 500, 550)
			LibStub("AceConfigDialog-3.0"):Open("Prescription")
		end
	end
	_G["SLASH_PRESCRIPTION_MAIN1"] = "/rx"
	
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "OnLeaveCombat")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "OnEnterCombat")
	
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(msg)
		if Prescription.db.profile.blockOutgoing and string.find(msg, "<Rx>") and UnitInRaid("player") then
			return true
		end
		return nil
	end)
end

function Prescription:OnEnterCombat()
	inCombat = true
end

function Prescription:OnLeaveCombat()
	inCombat = false
end

function Prescription:Raid_Check()
	if GetNumRaidMembers() == 0 then
		self:Print("|cffff0000You are not in a raid!")
		return
	end
	if inCombat then
		self:Print("|cffff0000Combat produces irregular results, aborting check.")
		return
	end
	
	local raid = {}
	local location = GetRealZoneText()
	local compliant = 0
	local processed = 0
	for i = 1, GetNumRaidMembers() do
		--if the unit is online and near the raid group (within 100 yrds) cache the raid member's buffs
		if UnitIsConnected("raid"..i) and UnitIsVisible("raid"..i) then
			local n = 1
			if UnitBuff("raid"..i, n) == nil then
				if not raid[i] then raid[i] = {} end
				table.insert(raid[i], "No Buffs")
			end
			while UnitBuff("raid"..i, n) ~= nil do
				local name = UnitBuff("raid"..i, n)
				if not raid[i] then raid[i] = {} end
				table.insert(raid[i], name)
				n = n + 1
			end
		end
	end
	
	for i = 1, GetNumRaidMembers() do
		local e1, e2, f1, f2 = false, false, false, false
		local toon, _ = UnitName("raid"..i)
		--if the unit is online and near the raid group (within 100 yrds) check the raid member's buffs for consumables
		--this prevents false reports for offline raiders and raiders not in the instance with the raid
		if UnitIsConnected("raid"..i) and UnitIsVisible("raid"..i) then
			processed = processed + 1
			for j = 1, 24 do
				local temp = table.remove(raid[i])
				if temp == nil then
					break
				elseif temp == "No Buffs" then
					break
				else
					if self.db.profile.checkBattle then
						for k, v in pairs(self.Battle) do
							if temp == v then
								if v == "Bloodberry Elixir" and location ~= "Sunwell Plateau" then
									e1 = false
								else
									e1 = true
								end
							end
						end
					else
						e1 = true
					end
					if self.db.profile.checkGuardian then
						for k, v in pairs(self.Guardian) do
							if temp == v then
								e2 = true
							end
						end
					else
						e2 = true
					end
					if self.db.profile.checkFlask then
						for k, v in pairs(self.Flask) do
							if temp == v then
								if string.find(v, "Unstable") and location ~= "Gruul's Lair" then
									f1 = false
								elseif string.find(v, "Shattrath") and not shattZones[location] then
									f1 = false
								else
									f1 = true
								end
							end
						end
					else
						f1 = true
					end
					if self.db.profile.checkFood then
						for k, v in pairs(self.Food) do
							if temp == v then
								f2 = true
							end
						end
					else
						f2 = true
					end
				end
			end
			
			--Local message stubs
			local message = toon .. " is using: "
			local raid = "<Rx> " .. toon .. " is missing: "
			local whisper = "<Rx> You are missing: "
			
			--Logic for printing used consumables
			if e1 and self.db.profile.checkBattle then
				message = message .. "Battle, "
			end
			if e2 and self.db.profile.checkBattle then
				message = message .. "Guardian, "
			end
			if f1 and self.db.profile.checkFlask then
				message = message .. "Flask, "
			end
			if f2 and self.db.profile.checkFood then
				message = message .. "Food, "
			end
			if (not e1) and (not e2) and (not f1) and (not f2) then
				message = message .. "No Consumables Found"
			end
			
			-- Flask fix for whispering missing buffs
			--if they have a flask, by definition they have battle & guardian
			if f1 then
				e1, e2 = true, true
			end
			
			local noMessage = false
			--Logic for whispering missing buffs
			if not e1 then
				whisper = whisper .. "Battle elixir, "
				raid = raid .. "Battle Elixir, "
			end
			if not e2 then
				whisper = whisper .. "Guardian elixir, "
				raid = raid .. "Guardian Elixir, "
			end
			if (not f1) and (not e1) and (not e2) then
				whisper = whisper .. "Flask, "
				raid = raid .. "Flask, "
			end
			if not f2 then
				whisper = whisper .. "Food, "
				raid = raid .. "Food, "
			end
			
			if whisper == "<Rx> You are missing: " then
				noMessage = true
				compliant = compliant + 1
			end
			
			if not commTable[toon] then commTable[toon] = {} end
			table.insert(commTable[toon], message)
			if not noMessage then
				table.insert(commTable[toon], whisper)
				table.insert(commTable[toon], raid)
			end
			if noMessage then
				table.insert(commTable[toon], "No Message")
				table.insert(commTable[toon], "No Message")
			end
		end
	end

	--for each key in the commTable, the value is a numerically indexed table upto 3
	--index 1 refers to the message to be printed for the user only
	--index 2 refers to the message to be whispered to the raiders
	--index 3 refers to the message to be sent to raid/officer chat
	for k in pairs(commTable) do
		for i, v in pairs(commTable[k]) do
			if i == 1 then
				if self.db.profile.sendSelf then
					self:Print(v)
				end
			end
			if i == 2 then
				if self.db.profile.sendWhispers and (k ~= user) then
					if v ~= "No Message" then
						SendChatMessage(v, "WHISPER", nil, k)
					end
				end
			end
			if i == 3 then
				if self.db.profile.sendRaid then
					if v ~= "No Message" then
						SendChatMessage(v, "RAID")
					end
				end
				if self.db.profile.sendOfficer then
					if v ~= "No Message" then
						SendChatMessage(v, "OFFICER")
					end
				end
			end
		end
		
	end
	
	--print a compliance percent if enabled
	if self.db.profile.sendCompliance then
		if compliant == processed then
			SendChatMessage("100% Compliance, Thank You.", "RAID")
		else
			SendChatMessage(string.format("%d%% Compliance.", compliant / processed * 100), "RAID")
		end
	end
	
	--cleanup tables and flags
	for i in pairs(commTable) do commTable[i] = nil end
end
